<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="AUTHOR" CONTENT="Vincent Mahe">
	<META NAME="CREATED" CONTENT="20070821;11342500">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20070827;17351200">
</HEAD>
<BODY LANG="fr-FR" DIR="LTR">
<P><IMG SRC="../img/OpenEmbeDD_logo.png" NAME="graphics1" ALIGN=LEFT HSPACE=4 WIDTH=204 HEIGHT=97 BORDER=0><FONT FACE="Nimbus Sans L"><FONT SIZE=5><B>Tree
to List User Guide</B></FONT></FONT><BR CLEAR=LEFT>
</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>Introduction</FONT></FONT></H1>
<P>The Tree2List example has been set within the OpenEmbeDD research
project, in order to illustrate the good practices for the project
partners and as raw material for technical meetings.</P>
<P>The two metamodels are simple enough to be understood in few
minutes so the focus can be put on technical issues: tests, format
questions, user-friendly approach, documentation and other needed
thoughts.</P>
<P>The user guide you are reading is also an illustration of what a
user guide can look like, not a real user guide. So do not except
detailed informations about the Tree &amp; List tools :-).</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>The Tree meta model</FONT></FONT></H1>
<P><IMG SRC="../img/Tree_metamodel.png" NAME="graphics2" ALIGN=LEFT WIDTH=408 HEIGHT=172 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>This meta model is pretty simple and represents a tree whose
elements have a name and nodes' leaves can be of small, medium or big
size. The root element should be a Node.</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>The Element List meta
model</FONT></FONT></H1>
<P><IMG SRC="../img/List_metamodel.png" NAME="graphics3" ALIGN=LEFT WIDTH=369 HEIGHT=149 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>The ElementList meta model aims to represent an ordered list of
elements, each element having a name. The root element should be a
RootElement.</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>The Tree to ElementList
transformation principles</FONT></FONT></H1>
<P>Let “<I>MMTree</I>” be the tree meta model's name and
“<I>MMElementList</I>” be the ElementList meta models' name.</P>
<P>In this transformation, we want :</P>
<UL>
	<LI><P>the tree root (of type <I>MMTree!Node</I>) to be transformed
	into the Element list “root” (of type <I>MMElementList!RootElement</I>)</P>
	<LI><P>a <I>MMTree!Leaf</I> element should be transformed into an
	<I>MMElementList!CommonElement</I> element</P>
	<LI><P>the <I>MMElementList!RootElement</I>'s “elements”
	attribute should contain an <B>ordered set</B> composed of the
	“transformed equivalent” of the leaves such as :</P>
	<UL>
		<LI><P>all big sized leaves comes first (in the tree's DFS order)</P>
		<LI><P>then all medium sized leaves (still in the tree's DFS order)</P>
		<LI><P>then the small sized one (still in the tree's DFS order)</P>
	</UL>
</UL>
<P>The figure below instantiates a transformation example. The nodes'
names are represented by an integer and the tree root is named “0”.</P>
<P><IMG SRC="../img/schema.png" NAME="graphics5" ALIGN=LEFT WIDTH=642 HEIGHT=196 BORDER=0><BR CLEAR=LEFT>We
can easily see the biggest part of this transformation is to “build”
the “elements” attribute of the <I>MMElementList!RootElement</I>
object.</P>
<P>With a common imperative algorithm, we would use a recursive
function on the tree root's children which would build three
<I>MMElementList!CommonElement</I> list corresponding to the small,
medium and big leaves encoutered during the DFS. Briefly, the
algorithm would :</P>
<UL>
	<LI><P>test the current child type (node or leaf)</P>
	<LI><P>if it is a node, make a recursive call,</P>
	<LI><P>else, test the leaf size and create a
	<I>MMElementList!CommonElement</I> with the leaf's name as its own
	name. According to the leaf size, this new object would be queued in
	the matching list (big sized leaf, medium or small)</P>
</UL>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>Transformation
implementation in ATL</FONT></FONT></H1>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>The declarative way</I></FONT></FONT></H2>
<P>In this example, we want to match to the main ATL philosophy as
much as we can. I.e, we'll avoid to use any <B>called rules</B> in
our code.</P>
<P>In our transformation, we clearly see the creation of two matched
rules :</P>
<UL>
	<LI><P>“Tree-Root” (a “non contained <I>Node</I>”) To
	<I>MMElementList!RootElement</I></P>
	<LI><P><I>MMTree!Leaf</I>  To <I>MMElementList!CommonElement</I></P>
</UL>
<P>However it is important to note 
</P>
<UL>
	<LI><P>the leaves order is critical to our transformation. Hence,
	the leaves transformation is closely linked to its position in the
	“<I>children</I>” attribute of a <I>MMTree!Node</I></P>
</UL>
<UL>
	<LI><P>the <I>MMTree!Leaf</I>  elements are kept into the
	containment attribute of a <I>MMTree!Node</I>, hence the
	transformation will have to use ATL <B>traceability links</B> (which
	avoid us to use the <B>distinct</B> keyword)</P>
</UL>
<P>In order to compute the leaves order, we plan to create :</P>
<UL>
	<LI><P>a <I>getAllChildren</I> (recursive) helper which returns all
	<I>TreeElement</I> encountered during the DFS</P>
	<LI><P>a <I>getLeavesInOrder</I> helper which uses the list returned
	by a call to <I>getAllChildren</I> to retrieve then filter and sort
	all leaves in the needed order : let “<I>leaves”</I> being the
	returned list of leaves, we compute a 3 set partition <I>of leaves </I>:<I>
	</I>one “big leaves” list, one “medium leaves” list and one
	“small leaves” list. We then make an <B>union</B> of these 3
	lists which gives us the well ordered leave list used by the
	<B>traceability link</B> transforming each Leaf into an Element.</P>
</UL>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>The launcher</I></FONT></FONT></H2>
<P>The launcher configuration is pretty common as both meta models
have been created with the EMF Ecore plugin. There is no library and
no superimposed module.</P>
<P>As a sidenote, the &laquo;&nbsp;Tree&nbsp;&raquo; model instance
matching the example in this paper is available in the
&laquo;&nbsp;modelinstances&nbsp;&raquo; directory of the
&laquo;&nbsp;fr.cs.leplessis.example.tree&nbsp;&raquo; project. The
resulting &laquo;&nbsp;List&nbsp;&raquo; model instance should be
located in the &laquo;&nbsp;modelinstances&nbsp;&raquo; directory of
the &laquo;&nbsp;fr.cs.leplessis.example.list&nbsp;&raquo; project.</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>The transformation
implementation in Kermeta</FONT></FONT></H1>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>The imperative way
with Kermeta</I></FONT></FONT></H2>
<P>The transformation process we want to deploy is quite
straightforward as a single DFS can be used to build the
<I>RootElement</I>'s <I>CommonElement</I> list.</P>
<H3><FONT FACE="Nimbus Sans L">Software architecture</FONT></H3>
<P>Kermeta being strongly object oriented, it allows to “think”
and build any transformation on an OO architecture, using (almost)
all features one can use with any OO language.</P>
<P>The “Tree2List” transformation is composed 3 classes :</P>
<UL>
	<LI><P>the “Main” class contains the <I>main()</I> method which
	is the starting point</P>
	<LI><P>the “Tree2List” class contains the implementation of the
	transformation algorithm</P>
	<LI><P>the “ResourceHandler” class factorizes the load/save of a
	model instance</P>
</UL>
<H3><FONT FACE="Nimbus Sans L">The implementation</FONT></H3>
<P>The process is quite simple and follows a standard Kermeta
transformation process :</P>
<OL>
	<LI><P>“load” the model into a Kermeta resource</P>
	<LI><P>retrieve the tree's root (<I>MMTree.Node</I>)</P>
	<LI><P>launch the transformation on the node</P>
	<LI><P>retrieve the list root (<I>MMElementList.RootElement</I>)</P>
	<LI><P>“save” the resource into a XMI file</P>
</OL>
<P>The most interesting part is the algorithm contained in the
Tree2List class. This class contains 4 attributes :</P>
<UL>
	<LI><P>the tree's root node</P>
	<LI><P>3 ordered sets of <I>MMElementList.CommonElement
	</I>corresponding to the big, medium and small sized leaves
	encountered during the transformation</P>
</UL>
<P>The algorithm is a basic DFS of the tree. For each node (starting
by the tree's root), we explore its (ordered) list of children and
test their type :</P>
<UL>
	<LI><P>if it is a node, make a recursive call</P>
	<LI><P>if not (hence, a leaf), 
	</P>
	<UL>
		<LI><P>create a <I>MMElementList.CommonElement</I></P>
		<LI><P>copy the leaf's name attribute value into the
		<I>CommonElement</I>'s one</P>
		<LI><P>test the leaf's size attribute and add the created
		<I>CommonElement</I> into one of the 3 lists according to the size</P>
	</UL>
	<LI><P>once the DFS has ended, we have completed the 3 ordered lists
	of <I>CommonElement</I>. We concatenate them into one (big then
	medium then small) and return it</P>
</UL>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4>The launcher</FONT></FONT></H2>
<P>The launcher configuration is pretty common as both meta models
have been created with the EMF Ecore plugin. However it is <B>imperative</B>
both meta models' URI match their path as stated in the Kermeta FAQ :
<A HREF="http://www.kermeta.org/documents/faq/resource_load_exception"></A><A HREF="http://www.kermeta.org/documents/faq/resource_load_exception"></A><A HREF="http://www.kermeta.org/documents/faq/resource_load_exception">http://www.kermeta.org/documents/faq/resource_load_exception</A><A HREF="http://www.kermeta.org/documents/faq/resource_load_exception"></A><A HREF="http://www.kermeta.org/documents/faq/resource_load_exception"></A></P>
<P>As a sidenote, the &laquo;&nbsp;Tree&nbsp;&raquo; model instance
matching the example in this paper is available in the
&laquo;&nbsp;modelinstances&nbsp;&raquo; directory of the
&laquo;&nbsp;fr.cs.leplessis.example.tree&nbsp;&raquo; project. The
resulting &laquo;&nbsp;List&nbsp;&raquo; model instance should be
located in the &laquo;&nbsp;modelinstances&nbsp;&raquo; directory of
the &laquo;&nbsp;fr.cs.leplessis.example.list&nbsp;&raquo; project.</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>Legal</FONT></FONT></H1>
<P><B>Creation date:</B> July 5, 2007</P>
<P><B>Licence:</B> -</P>
<P><B>Copyright:</B> -</P>
<P><B>Authors:</B>	Cyril Faure, CS-SI, Le Plessis Robinson</P>
<P>		Freddy Allilaire, INRIA-Atlas</P>
<P>		Cyril Faucher, INRIA-Triskell</P>
<P>		Vincent Mah&eacute;, Cellule d'int&eacute;gration OpenEmbeDD</P>
<P><I>See each plug-in for their copyright and author(s)</I>.</P>
</BODY>
</HTML>